Index: src/perl/register-dataset.cgi
===================================================================
--- src/perl/register-dataset.cgi	(revision 5310)
+++ src/perl/register-dataset.cgi	(revision 5311)
@@ -3461,855 +4274,1026 @@
       <text>$FORM::review</text>
     </review>|;
 
-    # find out if a docid already exists...
-    my ($x, $y, $z) = split(/\./, $docid);
-    my $docidWithoutRev = $x . "." . $y;
-    debug("docid without rev: $docidWithoutRev");
-    my $reviewDocumentId = '';
-    my $response = $metacat->squery("<pathquery><querytitle>Moderator-Search</querytitle><querygroup operator='INTERSECT'><queryterm searchmode='contains' casesensitive='false'><value>$docidWithoutRev</value><pathexpr>/reviewHistory/review/packageId</pathexpr></queryterm></querygroup></pathquery>"); 
+	# find out if a docid already exists...
+	my ( $x, $y, $z ) = split( /\./, $docid );
+	my $docidWithoutRev = $x . "." . $y;
+	debug("docid without rev: $docidWithoutRev");
+	my $reviewDocumentId = '';
+	my $response         = $metacat->squery(
+"<pathquery><querytitle>Moderator-Search</querytitle><querygroup operator='INTERSECT'><queryterm searchmode='contains' casesensitive='false'><value>$docidWithoutRev</value><pathexpr>/reviewHistory/review/packageId</pathexpr></queryterm></querygroup></pathquery>"
+	);
 
-    my $doc = $response->content();
-    my $xmldoc = $parser->parse_string($doc);
+	my $doc    = $response->content();
+	my $xmldoc = $parser->parse_string($doc);
 
-    if ($xmldoc eq "" || $doc=~ /<error/) {
-        # not able to parse
-        debug("Unable to parse results for $docidWithoutRev query.");
-        return "Error: Unable to store review for the docid:".$docid;
-    } else {
-        my $findNodes = $xmldoc->findnodes('//resultset/document');
-        if ($findNodes->size() > 0) {
-            # found contact email address
-            my $node = '';
-            foreach $node ($findNodes->get_nodelist) {
-                $reviewDocumentId = findValue($node,'docid');
-            }
+	if ( $xmldoc eq "" || $doc =~ /<error/ ) {
 
-            # update the old document
-            $response = $metacat->read($reviewDocumentId);
-            $doc = $response->content();
-            $xmldoc = $parser->parse_string($doc);
+		# not able to parse
+		debug("Unable to parse results for $docidWithoutRev query.");
+		return "Error: Unable to store review for the docid:" . $docid;
+	}
+	else {
+		my $findNodes = $xmldoc->findnodes('//resultset/document');
+		if ( $findNodes->size() > 0 ) {
 
-            if ($xmldoc eq "" || $doc=~ /<error/) {
-                return " Unable to read the document from Metacat which has the old reviews for the docid:".$docid;
-            } else {
-                my ($reviewdoc, $temp) = split('</reviewHistory>', $doc);
-                $reviewdoc .= $review."\n</reviewHistory>\n";
-                $reviewDocumentId = incrementRevision($reviewDocumentId);
-                debug("Generating review history document for $reviewDocumentId");
-                debugDoc($reviewdoc);
-                $response = $metacat->update($reviewDocumentId, $reviewdoc);
-                if ($response != '1') {
-                    return " Unable to update the review on Metacat for the docid:".$docid;
-                } else {
-                    $response = $metacat->setaccess($reviewDocumentId, $userDN, "read", "allow", "denyFirst");
-                    if ($response != '1') {
-                        return " Unable to set access for the review document in Metacat for the docid:".$docid;
-                    }
-                    foreach (split(":", $moderators)) {
-                        $response = $metacat->setaccess($reviewDocumentId, $_, "all", "allow", "denyFirst");
-                        if ($response != '1') {
-                            return " Unable to set access for the review document in Metacat for the docid:".$docid;
-                        }
-                    }
-                }
-            }
-        } else {
-            #insert a new document
-            debug("no review history document found, generating a new one.");
+			# found contact email address
+			my $node = '';
+			foreach $node ( $findNodes->get_nodelist ) {
+				$reviewDocumentId = findValue( $node, 'docid' );
+			}
 
-            my $id = newAccessionNumber('esa_reviews', $metacat);
-            my $reviewDoc = '';
-            my $failMessage = " Unable to insert the review on Metacat for the docid:".$docid;
+			# update the old document
+			$response = $metacat->read($reviewDocumentId);
+			$doc      = $response->content();
+			$xmldoc   = $parser->parse_string($doc);
 
-            $reviewDoc .= "<?xml version=\"1.0\"?>";
-            $reviewDoc .= "<reviewHistory registryName=\"".$skinName."\">";
-            $reviewDoc .= $review;
-            $reviewDoc .= "</reviewHistory>";
-            $response = $metacat->insert($id, $reviewDoc);
+			if ( $xmldoc eq "" || $doc =~ /<error/ ) {
+				return
+" Unable to read the document from Metacat which has the old reviews for the docid:"
+				  . $docid;
+			}
+			else {
+				my ( $reviewdoc, $temp ) = split( '</reviewHistory>', $doc );
+				$reviewdoc .= $review . "\n</reviewHistory>\n";
+				$reviewDocumentId = incrementRevision($reviewDocumentId);
+				debug(
+					"Generating review history document for $reviewDocumentId");
+				debugDoc($reviewdoc);
+				$response = $metacat->update( $reviewDocumentId, $reviewdoc );
+				if ( $response != '1' ) {
+					return
+					  " Unable to update the review on Metacat for the docid:"
+					  . $docid;
+				}
+				else {
+					$response =
+					  $metacat->setaccess( $reviewDocumentId, $userDN, "read",
+						"allow", "denyFirst" );
+					if ( $response != '1' ) {
+						return
+" Unable to set access for the review document in Metacat for the docid:"
+						  . $docid;
+					}
+					foreach ( split( ":", $moderators ) ) {
+						$response =
+						  $metacat->setaccess( $reviewDocumentId, $_, "all",
+							"allow", "denyFirst" );
+						if ( $response != '1' ) {
+							return
+" Unable to set access for the review document in Metacat for the docid:"
+							  . $docid;
+						}
+					}
+				}
+			}
+		}
+		else {
 
-            if ($response != '1') {
-                return $failMessage;
-            } else {
-                # set access
-                $response = $metacat->setaccess($id, $userDN, "read", "allow", "denyFirst");
-                if ($response != '1') {
-                    return $failMessage;
-                }
-                foreach (split(":", $moderators)) {
-                    $response = $metacat->setaccess($id, $_, "all", "allow", "denyFirst");
-                    if ($response != '1') {
-                        return $failMessage;
-                    }
-                }
-                # DENY all public access to these documents
-                $response = $metacat->setaccess($id, 'public', "all", "deny", "denyFirst");
-                if ($response != '1') {
-                    return $failMessage;
-                }
+			#insert a new document
+			debug("no review history document found, generating a new one.");
 
-            }
-        }
-    }
+			my $id = newAccessionNumber( 'esa_reviews', $metacat );
+			my $reviewDoc = '';
+			my $failMessage =
+			  " Unable to insert the review on Metacat for the docid:" . $docid;
 
-    return '';
-    # find out if a document already exist. if not then insert a new one. otherwise update the old one    
-    # the owner of the document is the moderator 
+			$reviewDoc .= "<?xml version=\"1.0\"?>";
+			$reviewDoc .= "<reviewHistory registryName=\"" . $skinName . "\">";
+			$reviewDoc .= $review;
+			$reviewDoc .= "</reviewHistory>";
+			$response = $metacat->insert( $id, $reviewDoc );
+
+			if ( $response != '1' ) {
+				return $failMessage;
+			}
+			else {
+
+				# set access
+				$response = $metacat->setaccess( $id, $userDN, "read", "allow",
+					"denyFirst" );
+				if ( $response != '1' ) {
+					return $failMessage;
+				}
+				foreach ( split( ":", $moderators ) ) {
+					$response = $metacat->setaccess( $id, $_, "all", "allow",
+						"denyFirst" );
+					if ( $response != '1' ) {
+						return $failMessage;
+					}
+				}
+
+				# DENY all public access to these documents
+				$response = $metacat->setaccess( $id, 'public', "all", "deny",
+					"denyFirst" );
+				if ( $response != '1' ) {
+					return $failMessage;
+				}
+
+			}
+		}
+	}
+
+	return '';
+
+# find out if a document already exist. if not then insert a new one. otherwise update the old one
+# the owner of the document is the moderator
 }
 
 ################################################################################
-# 
-# send an email message to the moderator and the contact 
 #
+# send an email message to the moderator and the contact
+#
 ################################################################################
 sub modSendNotification {
-    my $title = shift;
-    my $contactEmailAddress = shift;
-    my $contactName = shift;
-    my $subject = shift;
+	my $title               = shift;
+	my $contactEmailAddress = shift;
+	my $contactName         = shift;
+	my $subject             = shift;
 
-    debug($subject);
-    # send notification to the user and the moderator
-    my $templateVars = { 'stage' => $FORM::stage };
-    my ($x, $y, $z) = split(/\./, $FORM::docid);
-    my $docidWithoutRev = $x.".".$y;
-    $$templateVars{'docid'} = $docidWithoutRev;
-    $$templateVars{'comment'} = $FORM::review;
-    $$templateVars{'contactName'} = $contactName;
-    $$templateVars{'dpTitle'} = $title;
-    $$templateVars{'registryUrl'} = $contextUrl . "/cgi-bin/register-dataset.cgi";
-    $$templateVars{'recipient_status'} = 'moderator';
-    sendNotification($email->{'sender'}, $email->{'recipient'}, $subject, 
-                            $templates->{'modEmailNotification'}, $templateVars);
-    if ($contactEmailAddress ne '') {
-        # send notification to contact email address specified in cfg   
-        $$templateVars{'recipient_status'} = 'user';
-        sendNotification($email->{'sender'}, $contactEmailAddress, 
-            $subject, $templates->{'modEmailNotification'}, $templateVars);
-    }
+	#debug($subject);
+	# send notification to the user and the moderator
+	my $templateVars = { 'stage' => $FORM::stage };
+	my ( $x, $y, $z ) = split( /\./, $FORM::docid );
+	my $docidWithoutRev = $x . "." . $y;
+	$$templateVars{'docid'}       = $docidWithoutRev;
+	$$templateVars{'fullDocid'}   = $FORM::docid;
+	if (hasContent($FORM::function)) {
+		$$templateVars{'function'}    = $FORM::function;
+	} else {
+		$$templateVars{'function'}    = 'unknown';
+	}
+	$$templateVars{'comment'}     = $FORM::review;
+	$$templateVars{'contactName'} = $contactName;
+	$$templateVars{'dpTitle'}     = $title;
+	$$templateVars{'registryUrl'} =
+	  $contextUrl . "/cgi-bin/register-dataset.cgi";
+	$$templateVars{'metacatUrl'}       = $metacatUrl;
+	$$templateVars{'contextUrl'}       = $contextUrl;
+	$$templateVars{'recipient_status'} = 'moderator';
+	debug(
+"modSendNotification - sending moderator notification to: $email->{'recipient'} with subject: $subject"
+	);
+	sendNotification( $email->{'sender'}, $email->{'recipient'}, $subject,
+		$templates->{'modEmailNotification'},
+		$templateVars );
+
+	if ( $contactEmailAddress ne '' ) {
+
+		# send notification to contact email address specified in cfg
+		$$templateVars{'recipient_status'} = 'user';
+		debug(
+"modSendNotification - sending user notification to: $contactEmailAddress with subject: $subject"
+		);
+		sendNotification( $email->{'sender'}, $contactEmailAddress, $subject,
+			$templates->{'modEmailNotification'},
+			$templateVars );
+	}
 }
 
 ################################################################################
-# 
-# send an email message notifying the moderator of a new submission 
 #
+# send an email message notifying the moderator of a new submission
+#
 ################################################################################
 sub sendNotification {
-    my $sender = shift;
-    my $recipient = shift;
-    my $subject = shift;
-    my $templateForm = shift;
-    my $templateVars = shift;
-    
-    # When testing, set recipient to your email address
-    # $recipient = 'walbridge@nceas.ucsb.edu';
-    my $smtp = Net::SMTP->new($email->{'mailhost'});
-    $smtp->mail($sender);
-    $smtp->to($recipient);
+	my $sender       = shift;
+	my $recipient    = shift;
+	my $subject      = shift;
+	my $templateForm = shift;
+	my $templateVars = shift;
 
-    $smtp->data;
-    $smtp->datasend("From: $sender\n");
-    $smtp->datasend("To: <$recipient>\n");
-    $smtp->datasend("Subject: $subject\n");
-    $smtp->datasend("\n");
+	# When testing, set recipient to your email address
+	# $recipient = 'walbridge@nceas.ucsb.edu';
+	my $smtp = Net::SMTP->new( $email->{'mailhost'} );
+	$smtp->mail($sender);
+	$smtp->to($recipient);
 
-    my $message;
-    $template->process($templateForm, $templateVars,\$message);
+	$smtp->data;
+	$smtp->datasend("From: $sender\n");
+	$smtp->datasend("To: <$recipient>\n");
+	$smtp->datasend("Subject: $subject\n");
+	$smtp->datasend("\n");
 
-    $smtp->datasend($message);
-    $smtp->dataend();
-    $smtp->quit;
+	my $message;
+	$template->process( $templateForm, $templateVars, \$message );
+
+	$smtp->datasend($message);
+	$smtp->dataend();
+	$smtp->quit;
 }
 
 ################################################################################
-# 
-# sends back the result to the use 
 #
+# sends back the result to the use
+#
 ################################################################################
-sub processResultTemplate(){
-    my $stage = shift;
-    my $result = shift;
-    my $message = shift;
+sub processResultTemplate() {
+	my $stage   = shift;
+	my $result  = shift;
+	my $message = shift;
 
-    if ($result eq 'success') {
-        if ($stage eq 'accept') {
-            $message = "Dataset (docid:".$FORM::docid.") accepted ";
-        } elsif ($stage eq 'decline') {
-            $message = "Dataset (docid:".$FORM::docid.") declined ";
-        } else {
-            $message = "Revision requested for dataset (docid:".$FORM::docid.") ";
-        }
-    } else {
-        if ($stage eq 'accept') {
-            $message = "Failure in accepting docid: ".$FORM::docid." (".$message.")";
-        } elsif($stage eq 'decline') {
-            $message = "Failure in declining docid: ".$FORM::docid." (".$message.")";
-        } else {
-            $message = "Failure in requesting revision of docid: ".$FORM::docid." (".$message.")";
-        }
-    }
-    $$templateVars{'message'} = $message;
-    $template->process($templates->{'modResult'}, $templateVars);
+	if ( $result eq 'success' ) {
+		if ( $stage eq 'accept' ) {
+			$message = "Dataset (docid:" . $FORM::docid . ") accepted ";
+		}
+		elsif ( $stage eq 'decline' ) {
+			$message = "Dataset (docid:" . $FORM::docid . ") declined ";
+		}
+		else {
+			$message =
+			  "Revision requested for dataset (docid:" . $FORM::docid . ") ";
+		}
+	}
+	else {
+		if ( $stage eq 'accept' ) {
+			$message =
+			    "Failure in accepting docid: "
+			  . $FORM::docid . " ("
+			  . $message . ")";
+		}
+		elsif ( $stage eq 'decline' ) {
+			$message =
+			    "Failure in declining docid: "
+			  . $FORM::docid . " ("
+			  . $message . ")";
+		}
+		else {
+			$message =
+			    "Failure in requesting revision of docid: "
+			  . $FORM::docid . " ("
+			  . $message . ")";
+		}
+	}
+	$$templateVars{'message'} = $message;
+	$template->process( $templates->{'modResult'}, $templateVars );
 }
 
-
 ################################################################################
-# 
+#
 # Do data validation and send the data to confirm data template.
 #
 ################################################################################
-sub toConfirmData{
-    # Check if any invalid parameters
+sub toConfirmData {
 
-    my $invalidParams;
-    if (! $error) {
-        $invalidParams = validateParameters(0);
-        if (scalar(@$invalidParams)) {
-            $$templateVars{'status'} = 'failure';
-            $$templateVars{'invalidParams'} = $invalidParams;
-            $error = 1;
-        }
-    }
+	# Check if any invalid parameters
 
-    $$templateVars{'providerGivenName'} = normalizeCD($FORM::providerGivenName);
-    $$templateVars{'providerSurName'} = normalizeCD($FORM::providerSurName);
-    if ($FORM::site eq "Select your station here.") {
-        $$templateVars{'site'} = "";
-    } else {
-        $$templateVars{'site'} = $FORM::site;
-    }
-    if ($skinName eq "nceas") {
-        $$templateVars{'wg'} = \@FORM::wg;
-    }
-    $$templateVars{'identifier'} = normalizeCD($FORM::identifier);
-    $$templateVars{'title'} = normalizeCD($FORM::title);
-    $$templateVars{'origNamefirst0'} = normalizeCD($FORM::origNamefirst0);
-    $$templateVars{'origNamelast0'} = normalizeCD($FORM::origNamelast0);
-    $$templateVars{'origNameOrg'} = normalizeCD($FORM::origNameOrg);
-    $$templateVars{'origDelivery'} = normalizeCD($FORM::origDelivery);
-    $$templateVars{'origCity'} = normalizeCD($FORM::origCity);
-    if ($FORM::origState =~ /select state/i) {
-        $$templateVars{'origState'} = "";
-    } else {
-        $$templateVars{'origState'} = $FORM::origState;
-    }
-    $$templateVars{'origStateOther'} = normalizeCD($FORM::origStateOther);
-    $$templateVars{'origZIP'} = normalizeCD($FORM::origZIP);
-    $$templateVars{'origCountry'} = normalizeCD($FORM::origCountry);
-    $$templateVars{'origPhone'} = normalizeCD($FORM::origPhone);
-    $$templateVars{'origFAX'} = normalizeCD($FORM::origFAX);
-    $$templateVars{'origEmail'} = normalizeCD($FORM::origEmail);
-    $$templateVars{'useOrigAddress'} = normalizeCD($FORM::useOrigAddress);
-    if ($FORM::useOrigAddress eq "on") {
-        $$templateVars{'origNamefirstContact'} = normalizeCD($FORM::origNamefirst0);
-        $$templateVars{'origNamelastContact'} = normalizeCD($FORM::origNamelast0);
-        $$templateVars{'origNameOrgContact'} = normalizeCD($FORM::origNameOrg);
-        $$templateVars{'origDeliveryContact'} = normalizeCD($FORM::origDelivery); 
-        $$templateVars{'origCityContact'} = normalizeCD($FORM::origCity);
-        if ($FORM::origState =~ /select state/i) {
-            $$templateVars{'origStateContact'} = "";
-        } else {
-            $$templateVars{'origStateContact'} = $FORM::origState;
-        }
-        $$templateVars{'origStateOtherContact'} = normalizeCD($FORM::origStateOther);
-        $$templateVars{'origZIPContact'} = normalizeCD($FORM::origZIP);
-        $$templateVars{'origCountryContact'} = normalizeCD($FORM::origCountry);
-        $$templateVars{'origPhoneContact'} = normalizeCD($FORM::origPhone);
-        $$templateVars{'origFAXContact'} = normalizeCD($FORM::origFAX);
-        $$templateVars{'origEmailContact'} = normalizeCD($FORM::origEmail);
-    } else {
-        $$templateVars{'origNamefirstContact'} = normalizeCD($FORM::origNamefirstContact);
-        $$templateVars{'origNamelastContact'} = normalizeCD($FORM::origNamelastContact);
-        $$templateVars{'origNameOrgContact'} = normalizeCD($FORM::origNameOrgContact);
-        $$templateVars{'origDeliveryContact'} = normalizeCD($FORM::origDeliveryContact); 
-        $$templateVars{'origCityContact'} = normalizeCD($FORM::origCityContact);
-        if ($FORM::origStateContact =~ /select state/i) {
-            $$templateVars{'origStateContact'} = "";
-        } else {
-            $$templateVars{'origStateContact'} = $FORM::origStateContact;
-        }
-        $$templateVars{'origStateOtherContact'} = normalizeCD($FORM::origStateOtherContact);
-        $$templateVars{'origZIPContact'} = normalizeCD($FORM::origZIPContact);
-        $$templateVars{'origCountryContact'} = normalizeCD($FORM::origCountryContact);
-        $$templateVars{'origPhoneContact'} = normalizeCD($FORM::origPhoneContact);
-        $$templateVars{'origFAXContact'} = normalizeCD($FORM::origFAXContact);
-        $$templateVars{'origEmailContact'} = normalizeCD($FORM::origEmailContact);    
-    }
+	my $invalidParams;
+	if ( !$error ) {
+		$invalidParams = validateParameters(0);
+		if ( scalar(@$invalidParams) ) {
+			$$templateVars{'status'}        = 'failure';
+			$$templateVars{'invalidParams'} = $invalidParams;
+			$error                          = 1;
+		}
+	}
 
-    my $aoFNArray = \@FORM::aoFirstName;
-    my $aoLNArray = \@FORM::aoLastName;
-    my $aoRoleArray = \@FORM::aoRole;
-    my $aoCount = 1;
+	$$templateVars{'providerGivenName'} = normalizeCD($FORM::providerGivenName);
+	$$templateVars{'providerSurName'}   = normalizeCD($FORM::providerSurName);
+	if ( $FORM::site eq "Select your station here." ) {
+		$$templateVars{'site'} = "";
+	}
+	else {
+		$$templateVars{'site'} = $FORM::site;
+	}
+	if ( $skinName eq "nceas" ) {
+		$$templateVars{'wg'} = \@FORM::wg;
+	}
+	$$templateVars{'identifier'}     = normalizeCD($FORM::identifier);
+	$$templateVars{'title'}          = normalizeCD($FORM::title);
+	$$templateVars{'origNamefirst0'} = normalizeCD($FORM::origNamefirst0);
+	$$templateVars{'origNamelast0'}  = normalizeCD($FORM::origNamelast0);
+	$$templateVars{'origNameOrg'}    = normalizeCD($FORM::origNameOrg);
+	$$templateVars{'origDelivery'}   = normalizeCD($FORM::origDelivery);
+	$$templateVars{'origCity'}       = normalizeCD($FORM::origCity);
 
-    for (my $i = 0; $i <= $#$aoRoleArray; $i++) {
-        if (hasContent($aoFNArray->[$i]) && hasContent($aoLNArray->[$i])) {
-            debug("Processing Associated Party: origName = ".$aoFNArray->[$i]
-                  ." origNamelast = ".$aoLNArray->[$i]." origRole = "
-                  .$aoRoleArray->[$i]);
-            $$templateVars{"origNamefirst".$aoCount} = normalizeCD($aoFNArray->[$i]);
-            $$templateVars{"origNamelast".$aoCount} = normalizeCD($aoLNArray->[$i]);
-            $$templateVars{"origRole".$aoCount} = normalizeCD($aoRoleArray->[$i]);
-            $aoCount++;
-        }
-    }
+	if ( $FORM::origState =~ /select state/i ) {
+		$$templateVars{'origState'} = "";
+	}
+	else {
+		$$templateVars{'origState'} = $FORM::origState;
+	}
+	$$templateVars{'origStateOther'} = normalizeCD($FORM::origStateOther);
+	$$templateVars{'origZIP'}        = normalizeCD($FORM::origZIP);
+	$$templateVars{'origCountry'}    = normalizeCD($FORM::origCountry);
+	$$templateVars{'origPhone'}      = normalizeCD($FORM::origPhone);
+	$$templateVars{'origFAX'}        = normalizeCD($FORM::origFAX);
+	$$templateVars{'origEmail'}      = normalizeCD($FORM::origEmail);
+	$$templateVars{'useOrigAddress'} = normalizeCD($FORM::useOrigAddress);
+	if ( $FORM::useOrigAddress eq "on" ) {
+		$$templateVars{'origNamefirstContact'} =
+		  normalizeCD($FORM::origNamefirst0);
+		$$templateVars{'origNamelastContact'} =
+		  normalizeCD($FORM::origNamelast0);
+		$$templateVars{'origNameOrgContact'} = normalizeCD($FORM::origNameOrg);
+		$$templateVars{'origDeliveryContact'} =
+		  normalizeCD($FORM::origDelivery);
+		$$templateVars{'origCityContact'} = normalizeCD($FORM::origCity);
+		if ( $FORM::origState =~ /select state/i ) {
+			$$templateVars{'origStateContact'} = "";
+		}
+		else {
+			$$templateVars{'origStateContact'} = $FORM::origState;
+		}
+		$$templateVars{'origStateOtherContact'} =
+		  normalizeCD($FORM::origStateOther);
+		$$templateVars{'origZIPContact'}     = normalizeCD($FORM::origZIP);
+		$$templateVars{'origCountryContact'} = normalizeCD($FORM::origCountry);
+		$$templateVars{'origPhoneContact'}   = normalizeCD($FORM::origPhone);
+		$$templateVars{'origFAXContact'}     = normalizeCD($FORM::origFAX);
+		$$templateVars{'origEmailContact'}   = normalizeCD($FORM::origEmail);
+	}
+	else {
+		$$templateVars{'origNamefirstContact'} =
+		  normalizeCD($FORM::origNamefirstContact);
+		$$templateVars{'origNamelastContact'} =
+		  normalizeCD($FORM::origNamelastContact);
+		$$templateVars{'origNameOrgContact'} =
+		  normalizeCD($FORM::origNameOrgContact);
+		$$templateVars{'origDeliveryContact'} =
+		  normalizeCD($FORM::origDeliveryContact);
+		$$templateVars{'origCityContact'} = normalizeCD($FORM::origCityContact);
+		if ( $FORM::origStateContact =~ /select state/i ) {
+			$$templateVars{'origStateContact'} = "";
+		}
+		else {
+			$$templateVars{'origStateContact'} = $FORM::origStateContact;
+		}
+		$$templateVars{'origStateOtherContact'} =
+		  normalizeCD($FORM::origStateOtherContact);
+		$$templateVars{'origZIPContact'} = normalizeCD($FORM::origZIPContact);
+		$$templateVars{'origCountryContact'} =
+		  normalizeCD($FORM::origCountryContact);
+		$$templateVars{'origPhoneContact'} =
+		  normalizeCD($FORM::origPhoneContact);
+		$$templateVars{'origFAXContact'} = normalizeCD($FORM::origFAXContact);
+		$$templateVars{'origEmailContact'} =
+		  normalizeCD($FORM::origEmailContact);
+	}
 
-    $$templateVars{'aoCount'} = $aoCount;
-    $$templateVars{'abstract'} = normalizeCD($FORM::abstract);
+	my $aoFNArray   = \@FORM::aoFirstName;
+	my $aoLNArray   = \@FORM::aoLastName;
+	my $aoRoleArray = \@FORM::aoRole;
+	my $aoCount     = 1;
 
+	for ( my $i = 0 ; $i <= $#$aoRoleArray ; $i++ ) {
+		if ( hasContent( $aoFNArray->[$i] ) && hasContent( $aoLNArray->[$i] ) )
+		{
+			debug(  "Processing Associated Party: origName = "
+				  . $aoFNArray->[$i]
+				  . " origNamelast = "
+				  . $aoLNArray->[$i]
+				  . " origRole = "
+				  . $aoRoleArray->[$i] );
+			$$templateVars{ "origNamefirst" . $aoCount } =
+			  normalizeCD( $aoFNArray->[$i] );
+			$$templateVars{ "origNamelast" . $aoCount } =
+			  normalizeCD( $aoLNArray->[$i] );
+			$$templateVars{ "origRole" . $aoCount } =
+			  normalizeCD( $aoRoleArray->[$i] );
+			$aoCount++;
+		}
+	}
 
-    my $keywordArray = \@FORM::keyword;
-    my $keywordTypeArray = \@FORM::keywordType;
-    my $keywordThArray = \@FORM::keywordTh;
-    my $keyCount = 1;
+	$$templateVars{'aoCount'}  = $aoCount;
+	$$templateVars{'abstract'} = normalizeCD($FORM::abstract);
 
-    for (my $i = 0; $i <= $#$keywordArray; $i++) {
-        if (hasContent($keywordArray->[$i])) {
-            debug("Processing keyword: keyword = ".$keywordArray->[$i]."
-                  keywordType = ".$keywordTypeArray->[$i]."
-                  keywordTh = ".$keywordThArray->[$i]);
-            $$templateVars{"keyword".$keyCount} = normalizeCD($keywordArray->[$i]);
-            $$templateVars{"kwType".$keyCount} = normalizeCD($keywordTypeArray->[$i]);
-            $$templateVars{"kwTh".$keyCount} = normalizeCD($keywordThArray->[$i]);
-            $keyCount++;
-        }
-    }
-    $$templateVars{'keyCount'} = $keyCount;
+	my $keywordArray     = \@FORM::keyword;
+	my $keywordTypeArray = \@FORM::keywordType;
+	my $keywordThArray   = \@FORM::keywordTh;
+	my $keyCount         = 1;
 
-    $$templateVars{'addComments'} = normalizeCD($FORM::addComments);
-    $$templateVars{'useConstraints'} = $FORM::useConstraints;
-    if ($FORM::useConstraints eq "other") {
-        $$templateVars{'useConstraintsOther'} = $FORM::useConstraintsOther;
-    }
-    $$templateVars{'url'} = $FORM::url;
-    $$templateVars{'dataMedium'} = $FORM::dataMedium;
-    if ($FORM::dataMedium eq "other") {
-        $$templateVars{'dataMediumOther'} = normalizeCD($FORM::dataMediumOther);
-    }
-    $$templateVars{'beginningYear'} = $FORM::beginningYear;
-    $$templateVars{'beginningMonth'} = $FORM::beginningMonth;
-    $$templateVars{'beginningDay'} = $FORM::beginningDay;
-    $$templateVars{'endingYear'} = $FORM::endingYear;
-    $$templateVars{'endingMonth'} = $FORM::endingMonth;
-    $$templateVars{'endingDay'} = $FORM::endingDay;
-    $$templateVars{'geogdesc'} = normalizeCD($FORM::geogdesc);
-    $$templateVars{'useSiteCoord'} = $FORM::useSiteCoord;
-    $$templateVars{'latDeg1'} = $FORM::latDeg1;
-    $$templateVars{'latMin1'} = $FORM::latMin1;
-    $$templateVars{'latSec1'} = $FORM::latSec1;
-    $$templateVars{'hemisphLat1'} = $FORM::hemisphLat1;
-    $$templateVars{'longDeg1'} = $FORM::longDeg1;
-    $$templateVars{'longMin1'} = $FORM::longMin1;
-    $$templateVars{'longSec1'} = $FORM::longSec1;
-    $$templateVars{'hemisphLong1'} = $FORM::hemisphLong1;
-    $$templateVars{'latDeg2'} = $FORM::latDeg2;
-    $$templateVars{'latMin2'} = $FORM::latMin2;
-    $$templateVars{'latSec2'} = $FORM::latSec2;
-    $$templateVars{'hemisphLat2'} = $FORM::hemisphLat2;
-    $$templateVars{'longDeg2'} = $FORM::longDeg2;
-    $$templateVars{'longMin2'} = $FORM::longMin2;
-    $$templateVars{'longSec2'} = $FORM::longSec2;
-    $$templateVars{'hemisphLong2'} = $FORM::hemisphLong2;
+	for ( my $i = 0 ; $i <= $#$keywordArray ; $i++ ) {
+		if ( hasContent( $keywordArray->[$i] ) ) {
+			debug(
+				"Processing keyword: keyword = " . $keywordArray->[$i] . "
+                  keywordType = " . $keywordTypeArray->[$i] . "
+                  keywordTh = " . $keywordThArray->[$i]
+			);
+			$$templateVars{ "keyword" . $keyCount } =
+			  normalizeCD( $keywordArray->[$i] );
+			$$templateVars{ "kwType" . $keyCount } =
+			  normalizeCD( $keywordTypeArray->[$i] );
+			$$templateVars{ "kwTh" . $keyCount } =
+			  normalizeCD( $keywordThArray->[$i] );
+			$keyCount++;
+		}
+	}
+	$$templateVars{'keyCount'} = $keyCount;
 
-    my $taxonRankArray = \@FORM::taxonRank;
-    my $taxonNameArray = \@FORM::taxonName;
-    my $taxonCount = 1;
+	$$templateVars{'addComments'}    = normalizeCD($FORM::addComments);
+	$$templateVars{'useConstraints'} = $FORM::useConstraints;
+	if ( $FORM::useConstraints eq "other" ) {
+		$$templateVars{'useConstraintsOther'} = $FORM::useConstraintsOther;
+	}
+	$$templateVars{'url'}        = $FORM::url;
+	$$templateVars{'dataMedium'} = $FORM::dataMedium;
+	if ( $FORM::dataMedium eq "other" ) {
+		$$templateVars{'dataMediumOther'} = normalizeCD($FORM::dataMediumOther);
+	}
+	$$templateVars{'beginningYear'}  = $FORM::beginningYear;
+	$$templateVars{'beginningMonth'} = $FORM::beginningMonth;
+	$$templateVars{'beginningDay'}   = $FORM::beginningDay;
+	$$templateVars{'endingYear'}     = $FORM::endingYear;
+	$$templateVars{'endingMonth'}    = $FORM::endingMonth;
+	$$templateVars{'endingDay'}      = $FORM::endingDay;
+	$$templateVars{'geogdesc'}       = normalizeCD($FORM::geogdesc);
+	$$templateVars{'useSiteCoord'}   = $FORM::useSiteCoord;
+	$$templateVars{'latDeg1'}        = $FORM::latDeg1;
+	$$templateVars{'latMin1'}        = $FORM::latMin1;
+	$$templateVars{'latSec1'}        = $FORM::latSec1;
+	$$templateVars{'hemisphLat1'}    = $FORM::hemisphLat1;
+	$$templateVars{'longDeg1'}       = $FORM::longDeg1;
+	$$templateVars{'longMin1'}       = $FORM::longMin1;
+	$$templateVars{'longSec1'}       = $FORM::longSec1;
+	$$templateVars{'hemisphLong1'}   = $FORM::hemisphLong1;
+	$$templateVars{'latDeg2'}        = $FORM::latDeg2;
+	$$templateVars{'latMin2'}        = $FORM::latMin2;
+	$$templateVars{'latSec2'}        = $FORM::latSec2;
+	$$templateVars{'hemisphLat2'}    = $FORM::hemisphLat2;
+	$$templateVars{'longDeg2'}       = $FORM::longDeg2;
+	$$templateVars{'longMin2'}       = $FORM::longMin2;
+	$$templateVars{'longSec2'}       = $FORM::longSec2;
+	$$templateVars{'hemisphLong2'}   = $FORM::hemisphLong2;
 
-    for (my $i = 0; $i <= $#$taxonNameArray; $i++) {
-        if (hasContent($taxonRankArray->[$i]) && hasContent($taxonNameArray->[$i])) {
-            debug("Processing keyword: trv = ".$taxonRankArray->[$i]
-                    ." trn = ".$taxonNameArray->[$i]);
-            $$templateVars{"taxonRankName".$taxonCount} = normalizeCD($taxonRankArray->[$i]);
-            $$templateVars{"taxonRankValue".$taxonCount} = normalizeCD($taxonNameArray->[$i]);
-            $taxonCount++;
-        }
-    }
+	my $taxonRankArray = \@FORM::taxonRank;
+	my $taxonNameArray = \@FORM::taxonName;
+	my $taxonCount     = 1;
 
-    $$templateVars{'taxaCount'} = $taxonCount-1;
-    $$templateVars{'taxaAuth'} = normalizeCD($FORM::taxaAuth);
-    my $deleteCount = 0;
+	for ( my $i = 0 ; $i <= $#$taxonNameArray ; $i++ ) {
+		if (   hasContent( $taxonRankArray->[$i] )
+			&& hasContent( $taxonNameArray->[$i] ) )
+		{
+			debug(  "Processing keyword: trv = "
+				  . $taxonRankArray->[$i]
+				  . " trn = "
+				  . $taxonNameArray->[$i] );
+			$$templateVars{ "taxonRankName" . $taxonCount } =
+			  normalizeCD( $taxonRankArray->[$i] );
+			$$templateVars{ "taxonRankValue" . $taxonCount } =
+			  normalizeCD( $taxonNameArray->[$i] );
+			$taxonCount++;
+		}
+	}
 
-    for (my $i = 0; $i <= scalar(@FORM::deletefile); $i++) {
-        my $delfile = pop(@FORM::deletefile);
-        $$templateVars{"deletefile_$deleteCount"} = $delfile;
-        debug(" creating deletefile_$deleteCount = $delfile"); 
-        $deleteCount++;
-    }
-    $$templateVars{"delCount"} = $deleteCount;
-    for (my $upNum = 0; $upNum <= $FORM::upCount; $upNum++) {
-        my $upn = "upload_$upNum";
-        if (hasContent(param($upn))) {
-            debug("Processing existing file: $upn");
-            $$templateVars{"upload_$upNum"} = param("upload_$upNum");
-            $$templateVars{"uploadname_$upNum"} = param("uploadname_$upNum");
-            $$templateVars{"uploadtype_$upNum"} = param("uploadtype_$upNum");
-            $$templateVars{"uploadperm_$upNum"} = param("uploadperm_$upNum");
-        }
-    }
+	$$templateVars{'taxaCount'} = $taxonCount - 1;
+	$$templateVars{'taxaAuth'}  = normalizeCD($FORM::taxaAuth);
+	my $deleteCount = 0;
 
-    my $uploadCount = 0;
-    for (my $fileNum = 0; $fileNum <= $FORM::fileCount; $fileNum++) {
-        my $fn = 'file_' . $fileNum;
-        if (hasContent(param($fn))) {
-            my $fileName = eval "\$FORM::file_$fileNum";
-            debug("Processing file: $fn");
-            # Upload the file object itself to a temporary file, copy file metadata to form
-            my $fileInfo = processFile($fileName);
-            $$templateVars{"upload_$fileNum"} = $fileInfo->{'fileHash'};
-            $$templateVars{"uploadname_$fileNum"} = $fileInfo->{'fileName'};
-            $$templateVars{"uploadtype_$fileNum"} = $fileInfo->{'contentType'};
-            $$templateVars{"uploadperm_$fileNum"} = param("uploadperm_$fileNum");
-            $uploadCount++;
-        }
-    }
-    # total uploads are: new uploads - deleted files + original uploads
-    $$templateVars{'upCount'} = $uploadCount + $FORM::upCount;
-    $$templateVars{'methodTitle'} = normalizeCD($FORM::methodTitle);
+	for ( my $i = 0 ; $i <= scalar(@FORM::deletefile) ; $i++ ) {
+		my $delfile = pop(@FORM::deletefile);
+		$$templateVars{"deletefile_$deleteCount"} = $delfile;
+		debug(" creating deletefile_$deleteCount = $delfile");
+		$deleteCount++;
+	}
+	$$templateVars{"delCount"} = $deleteCount;
+	for ( my $upNum = 0 ; $upNum <= $FORM::upCount ; $upNum++ ) {
+		my $upn = "upload_$upNum";
+		if ( hasContent( param($upn) ) ) {
+			debug("Processing existing file: $upn");
+			$$templateVars{"upload_$upNum"}     = param("upload_$upNum");
+			$$templateVars{"uploadname_$upNum"} = param("uploadname_$upNum");
+			$$templateVars{"uploadtype_$upNum"} = param("uploadtype_$upNum");
+			$$templateVars{"uploadperm_$upNum"} = param("uploadperm_$upNum");
+		}
+	}
 
-    my @tempMethodPara;
-    for (my $i = 0; $i < scalar(@FORM::methodPara); $i++) {
-        $tempMethodPara[$i] = normalizeCD($FORM::methodPara[$i]);
-    }
-    $$templateVars{'methodPara'} = \@tempMethodPara;
-    $$templateVars{'studyExtentDescription'} = normalizeCD($FORM::studyExtentDescription);
-    $$templateVars{'samplingDescription'} = normalizeCD($FORM::samplingDescription);
-    $$templateVars{'modules'} = $modules;
-    $$templateVars{'required'} = $required;
-    $$templateVars{'show'} = $show;
-    $$templateVars{'site'} = $FORM::site;
-    $$templateVars{'docid'} = $FORM::docid;
+	my $uploadCount = 0;
+	for ( my $fileNum = 0 ; $fileNum <= $FORM::fileCount ; $fileNum++ ) {
+		my $fn = 'file_' . $fileNum;
+		if ( hasContent( param($fn) ) ) {
+			my $fileName = eval "\$FORM::file_$fileNum";
+			debug("Processing file: $fn");
 
-    # Check if the session exists
-    my $session = CGI::Session->load();
-    if (!($session->is_empty || $session->is_expired)) {
-        $$templateVars{'userLoggedIn'} = 'true';
-    }
-    
-    # Errors from validation function. print the errors out using the response template
-    if (scalar(@errorMessages)) {
-        debug("Error messages found when confirming data.");
-        $$templateVars{'status'} = 'failure';
-        $$templateVars{'errorMessages'} = \@errorMessages;
-        $error = 1;
-    }
+ # Upload the file object itself to a temporary file, copy file metadata to form
+			my $fileInfo = processFile($fileName);
+			$$templateVars{"upload_$fileNum"}     = $fileInfo->{'fileHash'};
+			$$templateVars{"uploadname_$fileNum"} = $fileInfo->{'fileName'};
+			$$templateVars{"uploadtype_$fileNum"} = $fileInfo->{'contentType'};
+			$$templateVars{"uploadperm_$fileNum"} =
+			  param("uploadperm_$fileNum");
+			$uploadCount++;
+		}
+	}
 
-    if (!$error) {
-        # If no errors, then print out data in confirm Data template
-        $$templateVars{'section'} = "Confirm Data";
-        $template->process($templates->{'confirmData'}, $templateVars);
+	# total uploads are: new uploads - deleted files + original uploads
+	$$templateVars{'upCount'}     = $uploadCount + $FORM::upCount;
+	$$templateVars{'methodTitle'} = normalizeCD($FORM::methodTitle);
 
-    } else {    
-        # Create our HTML response and send it back
-        $$templateVars{'function'} = "submitted";
-        $$templateVars{'section'} = "Submission Status";
-        $template->process($templates->{'response'}, $templateVars);
-    }
+	my @tempMethodPara;
+	for ( my $i = 0 ; $i < scalar(@FORM::methodPara) ; $i++ ) {
+		$tempMethodPara[$i] = normalizeCD( $FORM::methodPara[$i] );
+	}
+	$$templateVars{'methodPara'} = \@tempMethodPara;
+	$$templateVars{'studyExtentDescription'} =
+	  normalizeCD($FORM::studyExtentDescription);
+	$$templateVars{'samplingDescription'} =
+	  normalizeCD($FORM::samplingDescription);
+#	$$templateVars{'origStateContact'} = $FORM::origState;
+	$$templateVars{'modules'}          = $modules;
+	$$templateVars{'required'}         = $required;
+	$$templateVars{'show'}             = $show;
+	$$templateVars{'site'}             = $FORM::site;
+	$$templateVars{'docid'}            = $FORM::docid;
+
+	# Check if the session exists
+	my $session = CGI::Session->load();
+	if ( !( $session->is_empty || $session->is_expired ) ) {
+		$$templateVars{'userLoggedIn'} = 'true';
+	}
+
+# Errors from validation function. print the errors out using the response template
+	if ( scalar(@errorMessages) ) {
+		debug("Error messages found when confirming data.");
+		$$templateVars{'status'}        = 'failure';
+		$$templateVars{'errorMessages'} = \@errorMessages;
+		$error                          = 1;
+	}
+
+	if ( !$error ) {
+
+		# If no errors, then print out data in confirm Data template
+		$$templateVars{'section'} = "Confirm Data";
+		$template->process( $templates->{'confirmData'}, $templateVars );
+
+	}
+	else {
+
+		# Create our HTML response and send it back
+		$$templateVars{'function'} = "submitted";
+		$$templateVars{'section'}  = "Submission Status";
+		$template->process( $templates->{'response'}, $templateVars );
+	}
 }
 
-
 ################################################################################
-# 
+#
 # From confirm Data template - user wants to make some changes.
 #
 ################################################################################
-sub confirmDataToReEntryData{
-    my @sortedSites;
-    foreach my $site (sort @sitelist) {
-        push(@sortedSites, $site);
-    }
+sub confirmDataToReEntryData {
+	my @sortedSites;
+	foreach my $site ( sort @sitelist ) {
+		push( @sortedSites, $site );
+	}
 
-    $$templateVars{'siteList'} = \@sortedSites;
-    $$templateVars{'section'} = "Re-Entry Form";
-    copyFormToTemplateVars();
-    $$templateVars{'docid'} = $FORM::docid;
+	$$templateVars{'siteList'} = \@sortedSites;
+	$$templateVars{'section'}  = "Re-Entry Form";
+	copyFormToTemplateVars();
+	$$templateVars{'docid'} = $FORM::docid;
 
-    $$templateVars{'form'} = 're_entry';
-    $template->process($templates->{'entry'}, $templateVars);
+	$$templateVars{'form'} = 're_entry';
+	$template->process( $templates->{'entry'}, $templateVars );
 }
 
-
 ################################################################################
-# 
+#
 # Copy form data to templateVars.....
 #
 ################################################################################
-sub copyFormToTemplateVars{
-    $$templateVars{'providerGivenName'} = $FORM::providerGivenName;
-    $$templateVars{'providerSurName'} = $FORM::providerSurName;
-    $$templateVars{'site'} = $FORM::site;
-    if ($skinName eq "nceas") {
-        my $projects = getProjectList($properties);
-        $$templateVars{'projects'} = $projects;
-        $$templateVars{'wg'} = \@FORM::wg;
-    }
-    $$templateVars{'identifier'} = $FORM::identifier;
-    $$templateVars{'title'} = $FORM::title;
-    $$templateVars{'origNamefirst0'} = $FORM::origNamefirst0;
-    $$templateVars{'origNamelast0'} = $FORM::origNamelast0;
-    $$templateVars{'origNameOrg'} = $FORM::origNameOrg;
-    $$templateVars{'origDelivery'} = $FORM::origDelivery;
-    $$templateVars{'origCity'} = $FORM::origCity;
-    $$templateVars{'origState'} = $FORM::origState;
-    $$templateVars{'origStateOther'} = $FORM::origStateOther;
-    $$templateVars{'origZIP'} = $FORM::origZIP;
-    $$templateVars{'origCountry'} = $FORM::origCountry;
-    $$templateVars{'origPhone'} = $FORM::origPhone;
-    $$templateVars{'origFAX'} = $FORM::origFAX;
-    $$templateVars{'origEmail'} = $FORM::origEmail;
-    if ($FORM::useSiteCoord ne "") {
-        $$templateVars{'useOrigAddress'} = "CHECKED";
-    } else {
-        $$templateVars{'useOrigAddress'} = $FORM::useOrigAddress;
-    }
-    $$templateVars{'origNamefirstContact'} = $FORM::origNamefirstContact;
-    $$templateVars{'origNamelastContact'} = $FORM::origNamelastContact;
-    $$templateVars{'origNameOrgContact'} = $FORM::origNameOrgContact;
-    $$templateVars{'origDeliveryContact'} = $FORM::origDeliveryContact; 
-    $$templateVars{'origCityContact'} = $FORM::origCityContact;
-    $$templateVars{'origStateContact'} = $FORM::origStateContact;
-    $$templateVars{'origStateOtherContact'} = $FORM::origStateOtherContact;
-    $$templateVars{'origZIPContact'} = $FORM::origZIPContact;
-    $$templateVars{'origCountryContact'} = $FORM::origCountryContact;
-    $$templateVars{'origPhoneContact'} = $FORM::origPhoneContact;
-    $$templateVars{'origFAXContact'} = $FORM::origFAXContact;
-    $$templateVars{'origEmailContact'} = $FORM::origEmailContact;    
-    
-    $$templateVars{'aoCount'} = $FORM::aoCount;
-    foreach my $origName (param()) {
-    if ($origName =~ /origNamefirst/) {
-        my $origNameIndex = $origName;
-        $origNameIndex =~ s/origNamefirst//; # get the index of the parameter 0, ..., 10
-        my $origNamelast = "origNamelast".$origNameIndex;
-        my $origRole = "origRole".$origNameIndex;
-        if ($origNameIndex =~ /[0-9]+/  && $origNameIndex > 0) {
-        if (hasContent(param($origName)) && hasContent(param($origNamelast)) && hasContent(param($origRole))) {
-            debug("Processing keyword: $origName = ".param($origName)." $origNamelast = ".param($origNamelast)." $origRole = ".param($origRole));
-            $$templateVars{$origName} = normalizeCD(param($origName));
-            $$templateVars{$origNamelast} = normalizeCD(param($origNamelast));
-            $$templateVars{$origRole} = normalizeCD(param($origRole));
-        }
-        }
-    }
-    }
+sub copyFormToTemplateVars {
+	$$templateVars{'providerGivenName'} = $FORM::providerGivenName;
+	$$templateVars{'providerSurName'}   = $FORM::providerSurName;
+	$$templateVars{'site'}              = $FORM::site;
+	if ( $skinName eq "nceas" ) {
+		my $projects = getProjectList($properties);
+		$$templateVars{'projects'} = $projects;
+		$$templateVars{'wg'}       = \@FORM::wg;
+	}
+	$$templateVars{'identifier'}     = $FORM::identifier;
+	$$templateVars{'title'}          = $FORM::title;
+	$$templateVars{'origNamefirst0'} = $FORM::origNamefirst0;
+	$$templateVars{'origNamelast0'}  = $FORM::origNamelast0;
+	$$templateVars{'origNameOrg'}    = $FORM::origNameOrg;
+	$$templateVars{'origDelivery'}   = $FORM::origDelivery;
+	$$templateVars{'origCity'}       = $FORM::origCity;
+	$$templateVars{'origState'}      = $FORM::origState;
+	$$templateVars{'origStateOther'} = $FORM::origStateOther;
+	$$templateVars{'origZIP'}        = $FORM::origZIP;
+	$$templateVars{'origCountry'}    = $FORM::origCountry;
+	$$templateVars{'origPhone'}      = $FORM::origPhone;
+	$$templateVars{'origFAX'}        = $FORM::origFAX;
+	$$templateVars{'origEmail'}      = $FORM::origEmail;
 
-    $$templateVars{'abstract'} = $FORM::abstract;
-    $$templateVars{'keyCount'} = $FORM::keyCount;
-    foreach my $kyd (param()) {
-        if ($kyd =~ /keyword/) {
-            my $keyIndex = $kyd;
-            $keyIndex =~ s/keyword//; # get the index of the parameter 0, ..., 10
-            my $keyType = "kwType".$keyIndex;
-            my $keyTh = "kwTh".$keyIndex;
-            if ($keyIndex =~ /[0-9]+/) {
-                if (hasContent(param($kyd)) && hasContent(param($keyType)) && hasContent(param($keyTh))) {
-                    debug("Processing keyword: $kyd = ".param($kyd)." $keyType = ".param($keyType)." $keyTh = ".param($keyTh));
-                    $$templateVars{$kyd} = param($kyd);
-                    my $tmp = param($keyType);  #convert the first letter to upper case
-                    $tmp =~ s/\b(\w)/\U$1/g;
-                    $$templateVars{$keyType} = $tmp;
-                    $$templateVars{$keyTh} = param($keyTh);
-                }
-            }
-        }
-    }
+	if ( $FORM::useSiteCoord ne "" ) {
+		$$templateVars{'useOrigAddress'} = "CHECKED";
+	}
+	else {
+		$$templateVars{'useOrigAddress'} = $FORM::useOrigAddress;
+	}
+	$$templateVars{'origNamefirstContact'}  = $FORM::origNamefirstContact;
+	$$templateVars{'origNamelastContact'}   = $FORM::origNamelastContact;
+	$$templateVars{'origNameOrgContact'}    = $FORM::origNameOrgContact;
+	$$templateVars{'origDeliveryContact'}   = $FORM::origDeliveryContact;
+	$$templateVars{'origCityContact'}       = $FORM::origCityContact;
+	$$templateVars{'origStateContact'}      = $FORM::origStateContact;
+	$$templateVars{'origStateOtherContact'} = $FORM::origStateOtherContact;
+	$$templateVars{'origZIPContact'}        = $FORM::origZIPContact;
+	$$templateVars{'origCountryContact'}    = $FORM::origCountryContact;
+	$$templateVars{'origPhoneContact'}      = $FORM::origPhoneContact;
+	$$templateVars{'origFAXContact'}        = $FORM::origFAXContact;
+	$$templateVars{'origEmailContact'}      = $FORM::origEmailContact;
 
-    $$templateVars{'addComments'} = $FORM::addComments;
-    $$templateVars{'useConstraints'} = $FORM::useConstraints;
-    $$templateVars{'useConstraintsOther'} = $FORM::useConstraintsOther;
-    $$templateVars{'url'} = $FORM::url;
-    $$templateVars{'dataMedium'} = $FORM::dataMedium;
-    $$templateVars{'dataMediumOther'} = $FORM::dataMediumOther;
-    $$templateVars{'beginningYear'} = $FORM::beginningYear;
-    $$templateVars{'beginningMonth'} = $FORM::beginningMonth;
-    $$templateVars{'beginningDay'} = $FORM::beginningDay;
-    $$templateVars{'endingYear'} = $FORM::endingYear;
-    $$templateVars{'endingMonth'} = $FORM::endingMonth;
-    $$templateVars{'endingDay'} = $FORM::endingDay;
-    $$templateVars{'geogdesc'} = $FORM::geogdesc;
-    if ($FORM::useSiteCoord ne "") {
-        $$templateVars{'useSiteCoord'} = "CHECKED";
-    } else {
-        $$templateVars{'useSiteCoord'} = "";
-    }
-    $$templateVars{'latDeg1'} = $FORM::latDeg1;
-    $$templateVars{'latMin1'} = $FORM::latMin1;
-    $$templateVars{'latSec1'} = $FORM::latSec1;
-    $$templateVars{'hemisphLat1'} = $FORM::hemisphLat1;
-    $$templateVars{'longDeg1'} = $FORM::longDeg1;
-    $$templateVars{'longMin1'} = $FORM::longMin1;
-    $$templateVars{'longSec1'} = $FORM::longSec1;
-    $$templateVars{'hemisphLong1'} = $FORM::hemisphLong1;
-    $$templateVars{'latDeg2'} = $FORM::latDeg2;
-    $$templateVars{'latMin2'} = $FORM::latMin2;
-    $$templateVars{'latSec2'} = $FORM::latSec2;
-    $$templateVars{'hemisphLat2'} = $FORM::hemisphLat2;
-    $$templateVars{'longDeg2'} = $FORM::longDeg2;
-    $$templateVars{'longMin2'} = $FORM::longMin2;
-    $$templateVars{'longSec2'} = $FORM::longSec2;
-    $$templateVars{'hemisphLong2'} = $FORM::hemisphLong2;
-    $$templateVars{'taxaCount'} = $FORM::taxaCount;
-    foreach my $trn (param()) {
-        if ($trn =~ /taxonRankName/) {
-            my $taxIndex = $trn;
-            $taxIndex =~ s/taxonRankName//; # get the index of the parameter 0, ..., 10
-            my $trv = "taxonRankValue".$taxIndex;
-            if ($taxIndex =~ /[0-9]+/) {
-                if (hasContent(param($trn)) && hasContent(param($trv))) {
-                    debug("Processing taxon: $trn = ".param($trn)." $trv = ".param($trv));
-                    $$templateVars{$trn} = param($trn);
-                    $$templateVars{$trv} = param($trv);
-                }
-            }
-        }
-    }
-    $$templateVars{'taxaAuth'} = $FORM::taxaAuth;
-    $$templateVars{'methodTitle'} = $FORM::methodTitle;
-    $$templateVars{'methodPara'} = \@FORM::methodPara;
-    $$templateVars{'studyExtentDescription'} = $FORM::studyExtentDescription;
-    $$templateVars{'samplingDescription'} = $FORM::samplingDescription;
- 
-    $$templateVars{'modules'} = $modules; 
-    $$templateVars{'required'} = $required;
-    $$templateVars{'show'} = $show; 
-    $$templateVars{'site'} = $FORM::site;
-    $$templateVars{'fileCount'} = $FORM::fileCount;
-  
-    my $uploadCount = 0;
-    foreach my $upload (param()) {
-        if ($upload =~ /upload_/) {
-            my $fileIndex = $upload;
-            $fileIndex =~ s/upload_//;
-            if ($fileIndex =~ /[0-9]+/) {
-                if (hasContent(param($upload))) {
-                    debug("Returning filename: " . param($upload));
-                    $$templateVars{"upload_$fileIndex"} = param($upload);
-                    $$templateVars{"uploadname_$fileIndex"} = param("uploadname_$fileIndex");
-                    $$templateVars{"uploadtype_$fileIndex"} = param("uploadtype_$fileIndex");
-                    $$templateVars{"uploadperm_$fileIndex"} = param("uploadperm_$fileIndex");
-                    $uploadCount++;
-                }
-            }
-        }
-    }
+	$$templateVars{'aoCount'} = $FORM::aoCount;
+	foreach my $origName ( param() ) {
+		if ( $origName =~ /origNamefirst/ ) {
+			my $origNameIndex = $origName;
+			$origNameIndex =~
+			  s/origNamefirst//;    # get the index of the parameter 0, ..., 10
+			my $origNamelast = "origNamelast" . $origNameIndex;
+			my $origRole     = "origRole" . $origNameIndex;
+			if ( $origNameIndex =~ /[0-9]+/ && $origNameIndex > 0 ) {
+				if (   hasContent( param($origName) )
+					&& hasContent( param($origNamelast) )
+					&& hasContent( param($origRole) ) )
+				{
+					debug(  "Processing keyword: $origName = "
+						  . param($origName)
+						  . " $origNamelast = "
+						  . param($origNamelast)
+						  . " $origRole = "
+						  . param($origRole) );
+					$$templateVars{$origName} = normalizeCD( param($origName) );
+					$$templateVars{$origNamelast} =
+					  normalizeCD( param($origNamelast) );
+					$$templateVars{$origRole} = normalizeCD( param($origRole) );
+				}
+			}
+		}
+	}
 
-    $$templateVars{'upCount'} = $uploadCount;
+	$$templateVars{'abstract'} = $FORM::abstract;
+	$$templateVars{'keyCount'} = $FORM::keyCount;
+	foreach my $kyd ( param() ) {
+		if ( $kyd =~ /keyword/ ) {
+			my $keyIndex = $kyd;
+			$keyIndex =~
+			  s/keyword//;    # get the index of the parameter 0, ..., 10
+			my $keyType = "kwType" . $keyIndex;
+			my $keyTh   = "kwTh" . $keyIndex;
+			if ( $keyIndex =~ /[0-9]+/ ) {
+				if (   hasContent( param($kyd) )
+					&& hasContent( param($keyType) )
+					&& hasContent( param($keyTh) ) )
+				{
+					debug(  "Processing keyword: $kyd = "
+						  . param($kyd)
+						  . " $keyType = "
+						  . param($keyType)
+						  . " $keyTh = "
+						  . param($keyTh) );
+					$$templateVars{$kyd} = param($kyd);
+					my $tmp =
+					  param($keyType);   #convert the first letter to upper case
+					$tmp =~ s/\b(\w)/\U$1/g;
+					$$templateVars{$keyType} = $tmp;
+					$$templateVars{$keyTh}   = param($keyTh);
+				}
+			}
+		}
+	}
+
+	$$templateVars{'addComments'}         = $FORM::addComments;
+	$$templateVars{'useConstraints'}      = $FORM::useConstraints;
+	$$templateVars{'useConstraintsOther'} = $FORM::useConstraintsOther;
+	$$templateVars{'url'}                 = $FORM::url;
+	$$templateVars{'dataMedium'}          = $FORM::dataMedium;
+	$$templateVars{'dataMediumOther'}     = $FORM::dataMediumOther;
+	$$templateVars{'beginningYear'}       = $FORM::beginningYear;
+	$$templateVars{'beginningMonth'}      = $FORM::beginningMonth;
+	$$templateVars{'beginningDay'}        = $FORM::beginningDay;
+	$$templateVars{'endingYear'}          = $FORM::endingYear;
+	$$templateVars{'endingMonth'}         = $FORM::endingMonth;
+	$$templateVars{'endingDay'}           = $FORM::endingDay;
+	$$templateVars{'geogdesc'}            = $FORM::geogdesc;
+	if ( $FORM::useSiteCoord ne "" ) {
+		$$templateVars{'useSiteCoord'} = "CHECKED";
+	}
+	else {
+		$$templateVars{'useSiteCoord'} = "";
+	}
+	$$templateVars{'latDeg1'}      = $FORM::latDeg1;
+	$$templateVars{'latMin1'}      = $FORM::latMin1;
+	$$templateVars{'latSec1'}      = $FORM::latSec1;
+	$$templateVars{'hemisphLat1'}  = $FORM::hemisphLat1;
+	$$templateVars{'longDeg1'}     = $FORM::longDeg1;
+	$$templateVars{'longMin1'}     = $FORM::longMin1;
+	$$templateVars{'longSec1'}     = $FORM::longSec1;
+	$$templateVars{'hemisphLong1'} = $FORM::hemisphLong1;
+	$$templateVars{'latDeg2'}      = $FORM::latDeg2;
+	$$templateVars{'latMin2'}      = $FORM::latMin2;
+	$$templateVars{'latSec2'}      = $FORM::latSec2;
+	$$templateVars{'hemisphLat2'}  = $FORM::hemisphLat2;
+	$$templateVars{'longDeg2'}     = $FORM::longDeg2;
+	$$templateVars{'longMin2'}     = $FORM::longMin2;
+	$$templateVars{'longSec2'}     = $FORM::longSec2;
+	$$templateVars{'hemisphLong2'} = $FORM::hemisphLong2;
+	$$templateVars{'taxaCount'}    = $FORM::taxaCount;
+
+	foreach my $trn ( param() ) {
+		if ( $trn =~ /taxonRankName/ ) {
+			my $taxIndex = $trn;
+			$taxIndex =~
+			  s/taxonRankName//;    # get the index of the parameter 0, ..., 10
+			my $trv = "taxonRankValue" . $taxIndex;
+			if ( $taxIndex =~ /[0-9]+/ ) {
+				if ( hasContent( param($trn) ) && hasContent( param($trv) ) ) {
+					debug(  "Processing taxon: $trn = "
+						  . param($trn)
+						  . " $trv = "
+						  . param($trv) );
+					$$templateVars{$trn} = param($trn);
+					$$templateVars{$trv} = param($trv);
+				}
+			}
+		}
+	}
+	$$templateVars{'taxaAuth'}               = $FORM::taxaAuth;
+	$$templateVars{'methodTitle'}            = $FORM::methodTitle;
+	$$templateVars{'methodPara'}             = \@FORM::methodPara;
+	$$templateVars{'studyExtentDescription'} = $FORM::studyExtentDescription;
+	$$templateVars{'samplingDescription'}    = $FORM::samplingDescription;
+
+	$$templateVars{'modules'}   = $modules;
+	$$templateVars{'required'}  = $required;
+	$$templateVars{'show'}      = $show;
+	$$templateVars{'site'}      = $FORM::site;
+	$$templateVars{'fileCount'} = $FORM::fileCount;
+
+	my $uploadCount = 0;
+	foreach my $upload ( param() ) {
+		if ( $upload =~ /upload_/ ) {
+			my $fileIndex = $upload;
+			$fileIndex =~ s/upload_//;
+			if ( $fileIndex =~ /[0-9]+/ ) {
+				if ( hasContent( param($upload) ) ) {
+					debug( "Returning filename: " . param($upload) );
+					$$templateVars{"upload_$fileIndex"} = param($upload);
+					$$templateVars{"uploadname_$fileIndex"} =
+					  param("uploadname_$fileIndex");
+					$$templateVars{"uploadtype_$fileIndex"} =
+					  param("uploadtype_$fileIndex");
+					$$templateVars{"uploadperm_$fileIndex"} =
+					  param("uploadperm_$fileIndex");
+					$uploadCount++;
+				}
+			}
+		}
+	}
+
+	$$templateVars{'upCount'} = $uploadCount;
 }
 
 ################################################################################
-# 
+#
 # check if there is multiple occurence of the given tag and find its value.
 #
 ################################################################################
 
 sub findValue {
-    my $node = shift;
-    my $value = shift;
-    my $result;
-    my $tempNode;
+	my $node  = shift;
+	my $value = shift;
+	my $result;
+	my $tempNode;
 
-    $result = $node->findnodes("./$value");
-    if ($result->size > 1) {
-        errMoreThanOne("$value");
-    } else {
-        foreach $tempNode ($result->get_nodelist) {
-            #print $tempNode->nodeName().":".$tempNode->textContent();
-            #print "\n";
-            return $tempNode->textContent();
-        }
-    }
+	$result = $node->findnodes("./$value");
+	if ( $result->size > 1 ) {
+		errMoreThanOne("$value");
+	}
+	else {
+		foreach $tempNode ( $result->get_nodelist ) {
+
+			#print $tempNode->nodeName().":".$tempNode->textContent();
+			#print "\n";
+			return $tempNode->textContent();
+		}
+	}
 }
 
-
 ################################################################################
-# 
+#
 # check if given tags has any children. if not return the value
 #
 ################################################################################
 sub findValueNoChild {
-    my $node = shift;
-    my $value = shift;
-    my $tempNode;
-    my $childNodes;
-    my $result;
-    my $error;
+	my $node  = shift;
+	my $value = shift;
+	my $tempNode;
+	my $childNodes;
+	my $result;
+	my $error;
 
-    $result = $node->findnodes("./$value");
-    if ($result->size > 1) {
-       errMoreThanOne("$value");
-    } else {
-        foreach $tempNode ($result->get_nodelist) {
-            $childNodes = $tempNode->childNodes;
-            if ($childNodes->size() > 1) {
-                $error ="The tag $value has children which cannot be shown using the form. Please use Morpho to edit this document";    
-                push(@errorMessages, $error);
-            } else {
-                return $tempNode->textContent();
-            }
-        }
-    }
+	$result = $node->findnodes("./$value");
+	if ( $result->size > 1 ) {
+		errMoreThanOne("$value");
+	}
+	else {
+		foreach $tempNode ( $result->get_nodelist ) {
+			$childNodes = $tempNode->childNodes;
+			if ( $childNodes->size() > 1 ) {
+				$error =
+"The tag $value has children which cannot be shown using the form. Please use Morpho to edit this document";
+				push( @errorMessages, $error );
+			}
+			else {
+				return $tempNode->textContent();
+			}
+		}
+	}
 }
 
-
 ################################################################################
-# 
+#
 # check if given tags are children of given node.
 #
 ################################################################################
 sub dontOccur {
-    my $node = shift;
-    my $value = shift;
-    my $errVal = shift;
+	my $node   = shift;
+	my $value  = shift;
+	my $errVal = shift;
 
-    my $result = $node->findnodes("$value");
-    if ($result->size > 0) {
-        debug("Error trying to find $value, $errVal.");
-        $error ="One of the following tags found: $errVal. Please use Morpho to edit this document";
-        push(@errorMessages, $error."\n");
-    } 
+	my $result = $node->findnodes("$value");
+	if ( $result->size > 0 ) {
+		debug("Error trying to find $value, $errVal.");
+		$error = "One of the following tags found: $errVal. Please use Morpho to edit this document";
+		push( @errorMessages, $error . "\n" );
+	}
 }
 
-
 ################################################################################
-# 
+#
 # print out error for more than one occurence of a given tag
 #
 ################################################################################
 sub errMoreThanOne {
-    my $value = shift;
-    my $error ="More than one occurence of the tag $value found. Please use Morpho to edit this document";
-    push(@errorMessages, $error."\n");
+	my $value = shift;
+	my $error =
+"More than one occurence of the tag $value found. Please use Morpho to edit this document";
+	push( @errorMessages, $error . "\n" );
 }
 
-
 ################################################################################
-# 
+#
 # print out error for more than given number of occurences of a given tag
 #
 ################################################################################
 sub errMoreThanN {
-    my $value = shift;
-    my $error ="More occurences of the tag $value found than that can be shown in the form. Please use Morpho to edit this document";
-    push(@errorMessages, $error);
+	my $value = shift;
+	my $error =
+"More occurences of the tag $value found than that can be shown in the form. Please use Morpho to edit this document";
+	push( @errorMessages, $error );
 }
 
-
 ################################################################################
-# 
+#
 # print redirect html code
 #
 ################################################################################
-sub redirect(){
-    my $url = shift;
+sub redirect() {
+	my $url = shift;
 
-    print "<head>";
-    print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=".$url."\">";
-    print "</head><body></body></html>"; 
+	print "<head>";
+	print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=" . $url . "\">";
+	print "</head><body></body></html>";
 }
 
-
 ################################################################################
-# 
+#
 # print debugging messages to stderr
 #
 ################################################################################
 sub debug {
-    my $msg = shift;
-    
-    if ($debug_enabled) {
-        print STDERR "Registry: $msg\n";
-    }
-    else {
-        # This empty print statement is to prevent a bizzare error of the NCEAS
-        # skin failing when: debug = 0, and a file upload is attached. Maybe
-        # related to function return values?
-        print "";
-    }
+	my $msg = shift;
+
+	if ($debug_enabled) {
+		my $date = localtime();
+		print STDERR "Registry $date: $msg\n";
+	}
+	else {
+
+		# This empty print statement is to prevent a bizzare error of the NCEAS
+		# skin failing when: debug = 0, and a file upload is attached. Maybe
+		# related to function return values?
+		print "";
+	}
 }
 
 ################################################################################
-# 
+#
 # dump the EML document to disk
 #
 ################################################################################
 
 sub debugDoc {
-    my $doc = shift;
+	my $doc = shift;
 
-    if ($debug_enabled) {
-        # Write out the XML file for debugging purposes
-        my $testFile = $tempDir . "/registry-eml-upload.xml";
+	if ($debug_enabled) {
 
-        if (open (TFILE,">$testFile")) {
-        	print TFILE $doc;
-        	close(TFILE);
-        } else {
-        	debug("WARNING: Cant open xml file: $testFile");
-        }
-     }
+		# Write out the XML file for debugging purposes
+		my $testFile = $tempDir . "/registry-eml-upload.xml";
+
+		if ( open( TFILE, ">$testFile" ) ) {
+			print TFILE $doc;
+			close(TFILE);
+		}
+		else {
+			debug("WARNING: Cant open xml file: $testFile");
+		}
+	}
 }
 
 ################################################################################
-# 
+#
 # get the list of projects
 #
 ################################################################################
 sub getProjectList {
-    my $properties = shift;
-    my $projects;
+	my $properties = shift;
+	my $projects;
 
-    # Check for availability AdminDB.pm, for accessing NCEAS projects
-    eval { require NCEAS::AdminDB }; 
-    if ($@) {
-        $projects = getTestProjectList();
-    } else {
-        my $admindb = NCEAS::AdminDB->new();
+	# Check for availability AdminDB.pm, for accessing NCEAS projects
+	eval { require NCEAS::AdminDB };
+	if ($@) {
+		$projects = getTestProjectList();
+	}
+	else {
+		my $admindb = NCEAS::AdminDB->new();
 
-        # populate db parameters for NCEAS AdminDB
-        my $db = $skinProperties->splitToTree(qr/\./, 'registry.db');
+		# populate db parameters for NCEAS AdminDB
+		my $db = $skinProperties->splitToTree( qr/\./, 'registry.db' );
 
-        # check all neccessary parameters exist
-        if (!$db->{'connection'} || !$db->{'user'} || !$db->{'password'}) {
-            debug("NCEAS AdminDB misconfigured. Check database configuration parameters, in the registry.db section of nceas.properties.");
-            $projects = getTestProjectList();
-        } else {
-            $admindb->connect($db->{'connection'}, $db->{'user'}, $db->{'password'});
-            if ($admindb->{'connected'}) {
-                $projects = $admindb->getProjects();
-            } else {
-                $projects = getTestProjectList();
-            }
-        }
-    }
-    return $projects;
+		# check all neccessary parameters exist
+		if ( !$db->{'connection'} || !$db->{'user'} || !$db->{'password'} ) {
+			debug(
+"NCEAS AdminDB misconfigured. Check database configuration parameters, in the registry.db section of nceas.properties."
+			);
+			$projects = getTestProjectList();
+		}
+		else {
+			$admindb->connect( $db->{'connection'}, $db->{'user'},
+				$db->{'password'} );
+			if ( $admindb->{'connected'} ) {
+				$projects = $admindb->getProjects();
+			}
+			else {
+				$projects = getTestProjectList();
+			}
+		}
+	}
+	return $projects;
 }
 
 ################################################################################
-# 
+#
 # get a test list of projects for use only in testing where the NCEAS
 # admin db is not available.
 #
 ################################################################################
 sub getTestProjectList {
-    # This block is for testing only!  Remove for production use
-    my @row1;
-    $row1[0] = 6000; $row1[1] = 'Andelman'; $row1[2] = 'Sandy'; $row1[3] = 'The very long and windy path to an apparent ecological conclusion: statistics lie';
-    my @row2; 
-    $row2[0] = 7000; $row2[1] = 'Bascompte'; $row2[2] = 'Jordi'; $row2[3] = 'Postdoctoral Fellow';
-    my @row3; 
-    $row3[0] = 7001; $row3[1] = 'Hackett'; $row3[2] = 'Edward'; $row3[3] = 'Sociology rules the world';
-    my @row4; 
-    $row4[0] = 7002; $row4[1] = 'Jones'; $row4[2] = 'Matthew'; $row4[3] = 'Informatics rules the world';
-    my @row5; 
-    $row5[0] = 7003; $row5[1] = 'Schildhauer'; $row5[2] = 'Mark'; $row5[3] = 'Excel rocks my world, assuming a, b, and c';
-    my @row6; 
-    $row6[0] = 7004; $row6[1] = 'Rogers'; $row6[2] = 'Bill'; $row6[3] = 'Graduate Intern';
-    my @row7; 
-    $row7[0] = 7005; $row7[1] = 'Zedfried'; $row7[2] = 'Karl'; $row7[3] = 'A multivariate analysis of thing that go bump in the night';
-    my @projects;
-    $projects[0] = \@row1;
-    $projects[1] = \@row2;
-    $projects[2] = \@row3;
-    $projects[3] = \@row4;
-    $projects[4] = \@row5;
-    $projects[5] = \@row6;
-    $projects[6] = \@row7;
-    return \@projects;
+
+	# This block is for testing only!  Remove for production use
+	my @row1;
+	$row1[0] = 6000;
+	$row1[1] = 'Andelman';
+	$row1[2] = 'Sandy';
+	$row1[3] =
+'The very long and windy path to an apparent ecological conclusion: statistics lie';
+	my @row2;
+	$row2[0] = 7000;
+	$row2[1] = 'Bascompte';
+	$row2[2] = 'Jordi';
+	$row2[3] = 'Postdoctoral Fellow';
+	my @row3;
+	$row3[0] = 7001;
+	$row3[1] = 'Hackett';
+	$row3[2] = 'Edward';
+	$row3[3] = 'Sociology rules the world';
+	my @row4;
+	$row4[0] = 7002;
+	$row4[1] = 'Jones';
+	$row4[2] = 'Matthew';
+	$row4[3] = 'Informatics rules the world';
+	my @row5;
+	$row5[0] = 7003;
+	$row5[1] = 'Schildhauer';
+	$row5[2] = 'Mark';
+	$row5[3] = 'Excel rocks my world, assuming a, b, and c';
+	my @row6;
+	$row6[0] = 7004;
+	$row6[1] = 'Rogers';
+	$row6[2] = 'Bill';
+	$row6[3] = 'Graduate Intern';
+	my @row7;
+	$row7[0] = 7005;
+	$row7[1] = 'Zedfried';
+	$row7[2] = 'Karl';
+	$row7[3] = 'A multivariate analysis of thing that go bump in the night';
+	my @projects;
+	$projects[0] = \@row1;
+	$projects[1] = \@row2;
+	$projects[2] = \@row3;
+	$projects[3] = \@row4;
+	$projects[4] = \@row5;
+	$projects[5] = \@row6;
+	$projects[6] = \@row7;
+	return \@projects;
 }
